# Views Client-Side Faceted Filters Drupal Module

TODO

## Requirements
- [Views](https://www.drupal.org/project/views)

## Installation
Install as you would normally install a contributed Drupal module.
Visit https://www.drupal.org/node/1897420 for further information.

## Configuration
1. Create a view
2. Select


# Client-Side Faceted Filters Library
## Settings
~~~
{
  injection_selector: '#facets', // Facets container
  injection_method: 'append', // Facets container injection method
  facets: [
    // {
    //   id: 'lorem',
    //   title: 'Lorem',
    //   description: 'Moriatur, inquit.',
    // },
    // {
    //   id: 'ipsum',
    //   title: 'Ipsum',
    //   description: 'Restatis igitur vos.',
    // }
  ],
  show_facets: true, // Enable faceted filters
  show_fulltext_search: false, // Enable full text search
  values_count: true, // Show values count
  values_sort: 'value', // Sort values by
  values_sort_direction: 'asc', // Sort direction
  show_reset_button: true, // Show reset button
  reset_button_label: 'Reset', // Reset button label
  hidden_class: 'hidden', // The class to set for hidden (filtered) elements.
  // The following options are typically not changed, but we even allow that
  // for resolving possible conflicts:
  _csff_item_selector: '.csff-item',
  _csff_subitem_selector: '.csff-subitem',
  _csff_facet_data_attribute_prefix: 'data-csff-facet-',
  _csff_facet_data_attribute_key_suffix: '--key',
  _csff_facet_data_attribute_value_suffox: '--value',
  _csff_search_data_attribute: 'data-csff-search',
  _csff_search_data_attribute_value_suffix: '--value',
}
~~~

## Manually add facet data-attributes
### Control via DOM element classes and data attributes:
#### `.csff-item` Item Class (filterable / hidable item): \[REQUIRED\]
~~~
.csff-item
~~~

#### `.csff-subitem` Subitem Class (filterable, combined item, hiding parent item) \[OPTIONAL\]
~~~
.csff-subitem
~~~
**Required to be placed within `.csff-item` (`.csff-item .csff-subitem`)**

Marks a subitem, e.g. a product variation which itself has a matrix of filterable
properties.

*The key differences to .csff-item's are:*
1. A subitem is never hidden itself. If a `.csff-subitem` doesn't match active filter(s), its parent `.csff-item` is hidden.
2. If multiple filters are used, they are combined with **AND** per subitem. For example if a T-Shirt is available in Size M in Red and L in Blue and filtered to both properties, the property is only shown for available combinations.
If you don't want that functionality, simply don't declare the item as subitem.

#### `data-csff-facet-{ID}--value` Facet value data attribute \[REQUIRED\]
~~~
data-csff-facet-color--value="Red"
~~~

#### `data-csff-facet-{ID}--key` Facet key data attribute \[OPTIONAL\]
~~~
data-csff-facet-color--key="red"
~~~

---
### Fulltext search **(not yet implemented!)**
#### `.data-csff-search` Fulltext Search Item Class \[OPTIONAL\]
~~~
.data-csff-search
~~~
Uses the visible DOM output of this element and its subelements for full text search.

#### `data-csff-search--value` Fulltext search value data attribute \[OPTIONAL\]
~~~
data-csff-search--value="This is a full text attribute to use for search"
~~~
Optional data attribute to add further (invisible) text for fulltext searching.


### Examples:
The following examples show the flexibile possibilities to use the described
classes and data attributes to control facets and search:
#### Regular items with own data attributes:
~~~
<div
  class="csff-item"
  data-csff-facet-color--value="Red"
  data-csff-facet-color--key="red"

  data-csff-facet-size--value="XL">
  Super cool developer T-Shirt, Color: Red
</div>
~~~

#### Regular items with data attributes in fields
~~~
<div
  class="csff-item">
  Super cool developer T-Shirt,
  <span data-csff-facet-size--value="XL">
    Size: XL,
  </span>
  <span
    data-csff-facet-color--value="Red"
    data-csff-facet-color--key="red">
    Color: Red
  </span>
</div>
~~~

#### Regular item with data attributes in fields
~~~
<div
  class="csff-item">
  Super cool developer T-Shirt
  <div class="csff-subitem">
    <span data-csff-facet-color--value="Red"
      data-csff-facet-color--key="red">
      Red
    </span>
    T-Shirt,
    <span data-csff-facet-size--value="XL">
      Size: XL
    </span>
  </div>
  <div class="csff-subitem">
    <span data-csff-facet-color--value="Red"
      data-csff-facet-color--key="red">
      Red
    </span>
    T-Shirt,
    <span data-csff-facet-size--value="L">
      Size: L
    </span>
  </div>
  <div class="csff-subitem">
    <span data-csff-facet-color--value="Blue"
      data-csff-facet-color--key="blue">
      Blue
    </span>
    T-Shirt,
    <span data-csff-facet-size--value="L">
      Size: L
    </span>
  </div>
</div>
~~~
